Merge branch 'feature/debian-init-helpers-5305' into next

Fixes #5305
This commit is contained in:
Markus Frosch 2013-12-11 16:08:59 +01:00
commit 98671ebec2
1 changed files with 150 additions and 109 deletions

View File

@ -51,13 +51,9 @@ check_run () {
}
check_config () {
if ! $DAEMON --validate -u "$DAEMON_USER" -g "$DAEMON_GROUP" -c "$DAEMON_CONFIG" >/dev/null 2>&1; then
# blark output
$DAEMON --validate -u "$DAEMON_USER" -g "$DAEMON_GROUP" -c "$DAEMON_CONFIG"
fi
}
#
# Function that starts the daemon/service
#
@ -77,6 +73,18 @@ do_start()
# on this one. As a last resort, sleep for some time.
}
#
# Function that starts the daemon/service in foreground for debugging
#
do_foreground()
{
start-stop-daemon --start --quiet --pidfile $PIDFILE --exec $DAEMON --test \
|| return 1
start-stop-daemon --start --pidfile $PIDFILE --exec $DAEMON -- \
-c "$DAEMON_CONFIG" -u "$DAEMON_USER" -g "$DAEMON_GROUP" $DAEMON_ARGS \
|| return 2
}
#
# Function that stops the daemon/service
#
@ -116,17 +124,25 @@ do_reload() {
return 0
}
do_check_config () {
DOEXITONOK="$1"
log_begin_msg "checking Icinga2 configuration"
if ! check_config >/dev/null 2>&1; then
echo
check_config
log_failure_msg "checking Icinga2 configuration"
exit 1
else
log_end_msg 0
[ -n "$DOEXITONOK" ] && exit 0
fi
}
check_run
case "$1" in
start)
log_action_msg "checking Icinga2 configuration"
if ! check_config; then
log_failure_msg "config test failed!"
log_end_msg 1
exit 1
fi
do_check_config
log_daemon_msg "Starting $DESC" "$NAME"
do_start
case "$?" in
@ -134,6 +150,39 @@ case "$1" in
2) log_end_msg 1 ;;
esac
;;
foreground)
do_check_config
log_action_msg "Starting $DESC in foreground"
status=0
trap 'status=2;' INT # handle intr here
for i in 1 2; do
do_foreground || status="$?"
case "$status" in
0)
log_success_msg "$NAME ended graceful"
break
;;
1)
if [ "$i" -eq 1 ]; then
log_warning_msg "$NAME already running!"
log_begin_msg "Do you want to stop $NAME before going foreground? [y/N] "
read -r question
if [ "$question" = "y" ] || [ "$question" = "yes" ]; then
do_stop
continue
fi
fi
log_failure_msg "$NAME already running! Please stop before starting in foreground!"
break
;;
2)
log_failure_msg "$NAME ended"
break
;;
esac
done
exit $status
;;
stop)
log_daemon_msg "Stopping $DESC" "$NAME"
do_stop
@ -146,25 +195,13 @@ case "$1" in
status_of_proc "$DAEMON" "$NAME" && exit 0 || exit $?
;;
reload|force-reload)
log_action_msg "checking Icinga2 configuration"
if ! check_config; then
log_failure_msg "config test failed!"
log_end_msg 1
exit 1
fi
do_check_config
log_daemon_msg "Reloading $DESC" "$NAME"
do_reload
log_end_msg $?
;;
restart)
log_action_msg "checking Icinga2 configuration"
if ! check_config; then
log_failure_msg "config test failed!"
log_end_msg 1
exit 1
fi
do_check_config
log_daemon_msg "Restarting $DESC" "$NAME"
do_stop
case "$?" in
@ -182,10 +219,14 @@ case "$1" in
;;
esac
;;
checkconfig)
do_check_config 1
;;
*)
echo "Usage: $SCRIPTNAME {start|stop|status|reload|force-reload|restart}" >&2
echo "Usage: $SCRIPTNAME {start|stop|status|reload|force-reload|restart|checkconfig|foreground}" >&2
exit 3
;;
esac
# vi: ts=2 sw=2 expandtab :
: